<template>
	<list-search @searchData="searchData" @clearData="clearData" :search_params="commomParams.search"></list-search>
	<a-c-operation @refresh="clearData"></a-c-operation>
	<a-c-table :data="commomParams.table.data" :columns="commomParams.table.columns" :pagination="commomParams.page"
		@page="getPage" :loading="loading">
		<template #default="{ record }">
			<a-row :gutter="10">
				<a-col><a-button type="primary" size="small" primary @click="edit(record)">编辑/审核</a-button></a-col>
				<a-col><a-button type="primary" size="small" primary @click="detail(record)">详情</a-button></a-col>
				<a-col><a-button type="primary" size="small" primary
						@click="showCompany(record)">企业审核</a-button></a-col>
				<a-col><a-button type="primary" size="small" primary @click="addCompany(record)">加入企业</a-button></a-col>
				<a-popconfirm title="是否删除该招聘会?" @confirm="delOneRole(record.id)">
					<a-col><a-button type="primary" size="small" danger>删除</a-button></a-col>
				</a-popconfirm>
			</a-row>
		</template>
	</a-c-table>
	<list-add :edit_record="edit_record" @successAdd="successAdd" @closeAdd="closeAdd"></list-add>
	<list-detail :detail_record="detail_record"></list-detail>
	<list-company :company_record="company_record"></list-company>
	<list-add-company :add_company_record="add_company_record"></list-add-company>
</template>

<script lang="ts" setup>
	import { ref, onMounted, watch, computed } from 'vue';
	import ListSearch from '@/views/jobFair/list/search/index.vue';
	import ListAdd from '@/views/jobFair/list/add/add.vue';
	import ListDetail from '@/views/jobFair/list/detail/index.vue';
	import ListCompany from '@/views/jobFair/list/company/index.vue';
	import ListAddCompany from '@/views/jobFair/list/add-company/index.vue';
	import { listRecruitment, PostRecruitmentDel } from '@/apis/models';
	import { useCommon } from '@/hooks/useCommon';
	import { cols } from '@/views/jobFair/list/columns';
	import { message } from 'ant-design-vue';
	let { store, commomParams, showModal, showOtherModal1 } = useCommon();
	let loading = ref<Boolean>(true);
	onMounted(() => {
		getData(commomParams.value.search);
	})

	const searchData = (data : object) => {
		commomParams.value.search = data
		getData();
	}

	const clearData = (data : object) => {
		if (data) {
			commomParams.value.search = data
		} else {
			commomParams.value.search = {
				page: 1,
				pagesize: 10,
				sort: 'id',
				sortby: 'desc',
				keyword: ''
			}
		}
		getData();
	}


	const getPage = (data : object) => {
		commomParams.value.search.page = data.current;
		commomParams.value.search.pagesize = data.pageSize;
		getData();
	}
	const getData = async () => {
		try {
			loading.value = true;
			let res = await listRecruitment(commomParams.value.search);
			loading.value = false;
			commomParams.value.table.data = res.data.recruitments;
			commomParams.value.table.columns = cols;
			commomParams.value.page = {
				current: commomParams.value.search.page,
				pageSize: commomParams.value.search.pagesize,
				total: res.data.total,
				pageSizeOptions: ['10', '20', '30', '40'],
				hideOnSinglePage: false,
				showSizeChanger: true
			};
		} catch {
			loading.value = false;
		}
	}


	// 编辑
	let edit_record = ref<Object>(null)
	const edit = (record : object) => {
		edit_record.value = record;
		showModal()
	}
	const successAdd = () => {
		getData();
	}
	const closeAdd = () => {
		edit_record.value = null;
	}

	// 详情
	let detail_record = ref<Object>(null)
	const detail = (record) => {
		detail_record.value = record;
		showOtherModal1()
	}

	// 查看参与企业
	let company_record = ref<Object>(null)
	const showCompany = (record : object) => {
		company_record.value = record;
		store.commit('getShowCompanyModel', {
			showCompanyModel: true
		})
	}

	// 加入参与企业
	let add_company_record = ref<Object>(null)
	const addCompany = (record : object) => {
		add_company_record.value = record;
		store.commit('getShowAddCompanyModel', {
			showAddCompanyModel: true
		})
	}

	// 删除
	const delOneRole = (id : number) => {
		commomParams.value.delRecord = { id: id };
		PostRecruitmentDel(commomParams.value.delRecord).then(res => {
			message.success('删除成功');
			getData();
		})
	}
</script>

<style lang="less" scoped>

</style>